#include <stdio.h>
#include <d3dx9.h>

#pragma comment(lib,"d3d9.lib")
#pragma comment(lib,"d3dx9.lib")

#define MYWNDTITLE		"DX9_SeaBottom2"
#define MYWNDCLASS		"CLASS_DX9_SeaBottom2"
#define WIDTH			640 			// ʂ̉̃TCY
#define HEIGHT			480 			// ʂ̏c̃TCY
#define SEACOLOR		0x00004080
#define TAG_LEN			256				// ECTiBINjt@C̃^O̍ő啶
#define PI				(float)3.1415926535897932
#define RELEASE(p)		if (p){p->Release();p=NULL;}
#define DELETE2(p)		if (p){delete[] p;p=NULL;}
inline	DWORD FtoDW( FLOAT f ) { return *((DWORD*)&f); }

struct LVERTEX				// _tH[}bg̒`
{
	D3DXVECTOR3 v;			// W
	float		tu1,tv1;	// eNX`W1
	float		tu2,tv2;	// eNX`W2
};
#define FVF_LVERTEX (D3DFVF_XYZ | D3DFVF_TEX1 | D3DFVF_TEX2)

typedef struct{
	D3DXVECTOR3	*pv;			// _̍W
	float		*ptu,*ptv;		// _̃eNX`W
	int 		(*pf)[4];		// eʂ̒_ԍB_R̂Ƃ iv[3] = -1B
	int 		t_vtx_ct;		// _
	int 		t_face_ct;		// ʐ
	int 		parts_ct;		// p[c
}MODEL,*LPMODEL;

typedef struct{
	int 			vtx_ct;		// _
	int 			face_ct;	// ʐ
	int				flag_lap;	// eNX` bsÕtOi0,1:Ȃ 2:j
	D3DMATERIAL9	mtrl;		// }eA
	LPDIRECT3DTEXTURE9	pTex;	// eNX`
}PARTS,*LPPARTS;

LPDIRECT3D9 			g_pD3D = NULL;
LPDIRECT3DDEVICE9		g_pD3DDev = NULL;
D3DPRESENT_PARAMETERS	g_d3dpp;
LPDIRECT3DTEXTURE9		g_pTex2[32];// eNX`igej
MODEL		g_m1[2]; 				// IuWFNg̏i0:C 1:j
LPPARTS		g_pp1[2];				// IuWFNg̊ep[c̏i0:C 1:j
float		g_roll;				 	// IuWFNg̉]pxixj

HRESULT InitD3D(HWND hWnd);
bool	InitGeometry();
void	SetupMatrices();
void	Set_Light();
void	Draw_Main();
void	Draw_Object(int idx);
void	Get_Key();
void	Init_Global(int idx);
bool	Load_EctFile(int idx, char *filename);
bool	Load_EctFile_Bin(int idx, char *filename);
void	Cleanup();

LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg)
	{
	case WM_CREATE:
		if(FAILED(InitD3D(hWnd))){
			MessageBox(hWnd,"Ɏs܂",MYWNDTITLE,0);
			SendMessage(hWnd,WM_CLOSE,0,0);
			return 0;
		}
		SetTimer(hWnd,1,50,NULL);	//^C}[ݒB100 ̓^C}[Ԋu
		break;
		
	case WM_TIMER:
		Get_Key();					// L[͂̎擾
		Draw_Main();				// IuWFNg̕`
		break;
		
	case WM_KEYDOWN:
		switch ( wParam )
		{
			case VK_ESCAPE: 		// [ESC] L[ƏI
				SendMessage(hWnd, WM_CLOSE, 0, 0);
				break;
		}
		break;
		
	case WM_CLOSE:
		KillTimer(hWnd,1);			// ^C}[
		DestroyWindow(hWnd);
		Cleanup();					// Direct3D IuWFNg
		PostQuitMessage(0);
		break;

	default:
		return DefWindowProc(hWnd, uMsg, wParam, lParam);
	}
	return 0;
}

int WINAPI WinMain(HINSTANCE hInst,HINSTANCE hPrevInst,LPSTR lpCmdLine,int nCmdShow)
{
	WNDCLASSEX	wc;
	HWND		hWnd;

	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize			= sizeof(WNDCLASSEX); 
	wc.lpfnWndProc		= (WNDPROC)WndProc;
	wc.hInstance		= hInst;
	wc.hIcon			= LoadIcon(hInst,IDI_WINLOGO);
	wc.hCursor			= LoadCursor(NULL, MAKEINTRESOURCE(IDC_ARROW));
	wc.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);
	wc.lpszClassName	= MYWNDCLASS;
	if(RegisterClassEx(&wc) == 0)
		return 0;

	hWnd = CreateWindowEx(0, 
				MYWNDCLASS,
				MYWNDTITLE,
				WS_OVERLAPPED | WS_SYSMENU | WS_MINIMIZEBOX | WS_VISIBLE,
				CW_USEDEFAULT, CW_USEDEFAULT, WIDTH, HEIGHT,
				NULL,
				NULL,
				hInst,
				NULL);

	if(hWnd == NULL)
		return 0;

	MSG msg; 
	while(GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}

// D3D9̏
HRESULT InitD3D(HWND hWnd)
{
	// Direct3D9 쐬
	g_pD3D = Direct3DCreate9(D3D_SDK_VERSION);
	if (!g_pD3D){
		return E_FAIL;
	}
	
	ZeroMemory( &g_d3dpp, sizeof(g_d3dpp) );
	g_d3dpp.Windowed = TRUE;
	g_d3dpp.SwapEffect = D3DSWAPEFFECT_FLIP;
	g_d3dpp.BackBufferFormat = D3DFMT_UNKNOWN;
	g_d3dpp.EnableAutoDepthStencil = TRUE;
	g_d3dpp.AutoDepthStencilFormat = D3DFMT_D16;
	
	// D3D9Device 쐬
	if( FAILED( g_pD3D->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd,
									  D3DCREATE_SOFTWARE_VERTEXPROCESSING,
									  &g_d3dpp, &g_pD3DDev ) ) ){
		if( FAILED( g_pD3D->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_REF, hWnd,
									  D3DCREATE_SOFTWARE_VERTEXPROCESSING,
									  &g_d3dpp, &g_pD3DDev ) ) ){
			return E_FAIL;
		}
	}
	
	// eNX`Xe[W̎gp\H
	D3DCAPS9 caps;
	g_pD3DDev->GetDeviceCaps(&caps);
	if(caps.MaxSimultaneousTextures < 2){
		return E_FAIL;
	}
	
	int i,j;
	
	// ECTt@C̓ǂݍ
	if(!Load_EctFile(1,".\\fish.ect")){
		Load_EctFile_Bin(1,".\\fish.ect");
	}
	if(!Load_EctFile(0,".\\seafloor.ect")){
		Load_EctFile_Bin(0,".\\seafloor.ect");
	}
	
	// C̃eNX`WXP[O
	for(i=0;i<g_m1[0].t_vtx_ct;i++){
		g_m1[0].ptu[i] *= 5;
		g_m1[0].ptv[i] *= 5;
	}
	// CɍXɋNt
	for(i=0;i<2;i++){
		for(j=0;j<g_m1[0].t_vtx_ct;j++){
			g_m1[0].pv[j].y += 0.03f*(rand()/(float)RAND_MAX);
		}
	}
	
	// geeNX`̓ǂݍ
	char path[MAX_PATH];
	for(i=0;i<32;i++){
        sprintf(path, ".\\images\\Caust%02ld.tga", i);
		if(FAILED(D3DXCreateTextureFromFile(g_pD3DDev,path,&g_pTex2[i]))){
			g_pTex2[i] = NULL;
		}
	}
	// 
	if(!InitGeometry()){
		return E_FAIL;
	}
	
	return S_OK;
}//InitD3D

// ݒ̏
bool InitGeometry()
{
	// JO̐ݒ
	g_pD3DDev->SetRenderState(D3DRS_CULLMODE, D3DCULL_CCW);
	// Zobt@L
	g_pD3DDev->SetRenderState(D3DRS_ZENABLE, TRUE);
	// _tH[}bg̐ݒ
	g_pD3DDev->SetFVF(FVF_LVERTEX);
	// eNX`̐ݒ
//	g_pD3DDev->SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_TEXTURE);
//	g_pD3DDev->SetTextureStageState(0, D3DTSS_COLORARG2, D3DTA_DIFFUSE);
//	g_pD3DDev->SetTextureStageState(0, D3DTSS_COLOROP,	 D3DTOP_SELECTARG1);
	g_pD3DDev->SetTextureStageState(1, D3DTSS_COLORARG1, D3DTA_TEXTURE);
	g_pD3DDev->SetTextureStageState(1, D3DTSS_COLORARG2, D3DTA_CURRENT);
	g_pD3DDev->SetTextureStageState(1, D3DTSS_COLOROP,	 D3DTOP_ADD);
	g_pD3DDev->SetSamplerState     (0, D3DSAMP_MINFILTER, D3DTEXF_LINEAR);
	g_pD3DDev->SetSamplerState     (0, D3DSAMP_MAGFILTER, D3DTEXF_LINEAR);
	g_pD3DDev->SetSamplerState     (1, D3DSAMP_MINFILTER, D3DTEXF_LINEAR);
	g_pD3DDev->SetSamplerState     (1, D3DSAMP_MAGFILTER, D3DTEXF_LINEAR);
	
	// tHO̐ݒ
	FLOAT fFogStart =  0.5f;
	FLOAT fFogEnd	=  1.8f;
	g_pD3DDev->SetRenderState(D3DRS_FOGENABLE,		TRUE);
	g_pD3DDev->SetRenderState(D3DRS_FOGCOLOR,		SEACOLOR);
	g_pD3DDev->SetRenderState(D3DRS_FOGTABLEMODE,	D3DFOG_NONE);
	g_pD3DDev->SetRenderState(D3DRS_FOGVERTEXMODE,	D3DFOG_LINEAR);
	g_pD3DDev->SetRenderState(D3DRS_RANGEFOGENABLE, FALSE);
	g_pD3DDev->SetRenderState(D3DRS_FOGSTART,		FtoDW(fFogStart));
	g_pD3DDev->SetRenderState(D3DRS_FOGEND, 		FtoDW(fFogEnd));
	
	Set_Light();		// Cg̐ݒ
	SetupMatrices();	// ϊs̐ݒ
	
	return 1;
}// InitGeometry

// ϊs̐ݒ
void SetupMatrices()
{
	// J̈ʒu
	D3DXMATRIX matView;
	D3DXMatrixLookAtLH(&matView,&D3DXVECTOR3(0,0.5f,-0.8f),&D3DXVECTOR3(0,0,0),&D3DXVECTOR3(0,1,0));
	g_pD3DDev->SetTransform(D3DTS_VIEW,&matView);
	// E̍LƃAXyNgƋ
	D3DXMATRIX matProj;
	D3DXMatrixPerspectiveFovLH(&matProj,D3DX_PI/4,(float)WIDTH/HEIGHT,0.01f,10.0f);
	g_pD3DDev->SetTransform(D3DTS_PROJECTION,&matProj);
}// SetupMatrices

// Ɩݒ
void Set_Light()
{
	D3DXVECTOR3 vecDir;
	D3DLIGHT9	light;
	
	ZeroMemory( &light, sizeof(D3DLIGHT9) );
	light.Type		= D3DLIGHT_DIRECTIONAL;
	light.Diffuse.r = 1.0f;
	light.Diffuse.g = 1.0f;
	light.Diffuse.b = 1.0f;
	vecDir = D3DXVECTOR3(0.866025f,-0.5f,0.0f);
	D3DXVec3Normalize((D3DXVECTOR3*)&light.Direction, &vecDir);
	g_pD3DDev->SetLight(0, &light);
	g_pD3DDev->LightEnable(0, TRUE);
	g_pD3DDev->SetRenderState(D3DRS_LIGHTING, TRUE);
	g_pD3DDev->SetRenderState(D3DRS_AMBIENT, 0x00CCCCCC);
}// Set_Light

// `
void Draw_Main()
{	
	g_pD3DDev->Clear(0,NULL,D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER,SEACOLOR,1.0f,0);
	if( SUCCEEDED( g_pD3DDev->BeginScene() ) )
	{
		// [hϊݒ
		D3DXMATRIX	matRY;
		D3DXMatrixRotationY(&matRY,g_roll/180*PI);
		g_pD3DDev->SetTransform(D3DTS_WORLD,&matRY);
		
		static int	n = 0;
		g_pD3DDev->SetTexture(1, g_pTex2[n ++]);
		if(n >= 32){
			n = 0;
		}
		Draw_Object(0);	// C̕`
		Draw_Object(1);	// ̕`
		
		g_pD3DDev->EndScene();
		
		g_pD3DDev->SetTexture(0, NULL);
		g_pD3DDev->SetTexture(1, NULL);
	}
	g_pD3DDev->Present(NULL,NULL,NULL,NULL);
	
	// foCXƂ
	if(g_pD3DDev->TestCooperativeLevel() == D3DERR_DEVICENOTRESET){
		g_pD3DDev->Reset(&g_d3dpp);
		InitGeometry();
		Draw_Main();
	}
}// Draw_Main

// IuWFNg̕`
void Draw_Object(int idx)
{
	int 			i,j,k,v_idx,f_n;
	LVERTEX			lv[4];
	
	for(k=0;k<g_m1[idx].parts_ct;k++){
		if(g_pp1[idx][k].flag_lap == 2)	// eNX`bsOL
			g_pD3DDev->SetRenderState(D3DRS_WRAP0, D3DWRAPCOORD_0);
		else						// eNX`bsO
			g_pD3DDev->SetRenderState(D3DRS_WRAP0, 0);
		g_pD3DDev->SetMaterial(&g_pp1[idx][k].mtrl);	// }eAKp
		g_pD3DDev->SetTexture(0, g_pp1[idx][k].pTex);// eNX`Kp
		for(i=g_pp1[idx][k].face_ct;i<g_pp1[idx][k+1].face_ct;i++){
			for(j=0;j<4;j++){
				if(j != 3 || g_m1[idx].pf[i][3] != -1){
					v_idx = g_pp1[idx][k].vtx_ct + g_m1[idx].pf[i][j];
					lv[j].v   = g_m1[idx].pv [v_idx];
					lv[j].tu1 = g_m1[idx].ptu[v_idx];
					lv[j].tv1 = g_m1[idx].ptv[v_idx];
					lv[j].tu2 = g_m1[idx].ptu[v_idx];
					lv[j].tv2 = g_m1[idx].ptv[v_idx];
				}						
			}
			f_n = 2;
			if(g_m1[idx].pf[i][3] == -1)
				f_n = 1;
			g_pD3DDev->DrawPrimitiveUP(D3DPT_TRIANGLEFAN,f_n,lv,sizeof(LVERTEX));
		}
	}
}// Draw_Object

// L[
void Get_Key()
{
	if(GetAsyncKeyState(VK_LEFT) & 0x8000){ 		// []L[ꂽƂ
		g_roll -= 5;
		if(g_roll == 0)
			g_roll = 360;
	}
	else if(GetAsyncKeyState(VK_RIGHT) & 0x8000){	// []L[ꂽƂ
		g_roll += 5;
		if(g_roll == 360)
			g_roll = 0;
	}
}// Get_Key

// Oϐ̏
void Init_Global(int idx)
{
	int i;
	
	g_pD3DDev->SetTexture(idx, NULL);
	// eNX`
	for(i=0;i<g_m1[idx].parts_ct;i++){
		RELEASE(g_pp1[idx][i].pTex);
	}
	
	//̈
	DELETE2(g_pp1[idx]);
	DELETE2(g_m1[idx].pv);
	DELETE2(g_m1[idx].ptu);
	DELETE2(g_m1[idx].ptv);
	DELETE2(g_m1[idx].pf);
	
	ZeroMemory(&g_m1[idx], sizeof(g_m1[idx]));
}// Init_Global

// ECTt@C̓ǂݍ݁ieLXg`j
bool Load_EctFile(int idx, char *filename)
{
	FILE 	*file1;
	
	char 	ss[256],path[MAX_PATH],tex_name[MAX_PATH];
	float 	ww[8];
	int		flag = 0;
	int 	vv[4],p_ct = 0,ct1 = 0,ct2 = 0;
	int		i;
	
	Init_Global(idx);		// Oϐ̏
	
	if((file1=fopen(filename,"r")) == NULL){
		return 0;		
	}
	
	while(!feof(file1)){
		
		fgets(ss,256,file1);
		if(ss[strlen(ss)-1] == '\n'){
			ss[strlen(ss)-1] = '\0';
		}
		
		// p[c̐
		if(!strcmp(ss,"<parts_count>")){
			flag = 1;
		}
		else if(!strcmp(ss,"</parts_count>")){
			flag = 0;
		}
		else if(flag == 1){
			sscanf(ss,"%d",&g_m1[idx].parts_ct);
			g_pp1[idx] = new PARTS [g_m1[idx].parts_ct+1];
			for(i=0;i<g_m1[idx].parts_ct;i++){
				g_pp1[idx][i].vtx_ct = 0;
				g_pp1[idx][i].face_ct = 0;
			}
		}
		
		// IuWFNgŜ̒_W̐
		else if(!strcmp(ss,"<total_vertex_count>")){
			flag = 4;
		}
		else if(!strcmp(ss,"</total_vertex_count>")){
			flag = 0;
		}
		else if(flag == 4){
			sscanf(ss,"%d",&g_m1[idx].t_vtx_ct);
			g_m1[idx].pv  = new D3DXVECTOR3 [g_m1[idx].t_vtx_ct];
			g_m1[idx].ptu = new float       [g_m1[idx].t_vtx_ct];
			g_m1[idx].ptv = new float       [g_m1[idx].t_vtx_ct];
			ZeroMemory(g_m1[idx].ptu, g_m1[idx].t_vtx_ct * sizeof(float));
			ZeroMemory(g_m1[idx].ptv, g_m1[idx].t_vtx_ct * sizeof(float));
		}
		
		// IuWFNgŜ̖ʂ̐
		else if(!strcmp(ss,"<total_face_count>")){
			flag = 5;
		}
		else if(!strcmp(ss,"</total_face_count>")){
			flag = 0;
		}
		else if(flag == 5){
			sscanf(ss,"%d",&g_m1[idx].t_face_ct);
			g_m1[idx].pf = new int	   [g_m1[idx].t_face_ct][4];
		}
		
		// ǂݍ񂾃p[c̐
		else if(!strcmp(ss,"</polygon_mesh>")){
			p_ct ++;
		}
		
		// p[cƂ̃fBt[YF
		else if(!strcmp(ss,"<diffuse>")){
			flag = 6;
		}
		else if(!strcmp(ss,"</diffuse>")){
			flag = 0;
		}
		else if(flag == 6){
			sscanf(ss,"%f %f %f %f", &g_pp1[idx][p_ct].mtrl.Diffuse.a, &g_pp1[idx][p_ct].mtrl.Diffuse.r, &g_pp1[idx][p_ct].mtrl.Diffuse.g, &g_pp1[idx][p_ct].mtrl.Diffuse.b);
			g_pp1[idx][p_ct].mtrl.Ambient = g_pp1[idx][p_ct].mtrl.Diffuse;
		}
		
		// p[cƂ̃XyLF
		else if(!strcmp(ss,"<specular>")){
			flag = 7;
		}
		else if(!strcmp(ss,"</specular>")){
			flag = 0;
		}
		else if(flag == 7){
			sscanf(ss,"%f %f %f %f",&g_pp1[idx][p_ct].mtrl.Specular.a,&g_pp1[idx][p_ct].mtrl.Specular.r,&g_pp1[idx][p_ct].mtrl.Specular.g,&g_pp1[idx][p_ct].mtrl.Specular.b);
		}
		
		// p[cƂ̃G~bVF
		else if(!strcmp(ss,"<emission>")){
			flag = 8;
		}
		else if(!strcmp(ss,"</emission>")){
			flag = 0;
		}
		else if(flag == 8){
			sscanf(ss,"%f %f %f %f",&g_pp1[idx][p_ct].mtrl.Emissive.a,&g_pp1[idx][p_ct].mtrl.Emissive.r,&g_pp1[idx][p_ct].mtrl.Emissive.g,&g_pp1[idx][p_ct].mtrl.Emissive.b);
		}
		
		// XyLFx
		else if(!strcmp(ss,"<specular_power>")){
			flag = 9;
		}
		else if(!strcmp(ss,"</specular_power>")){
			flag = 0;
		}
		else if(flag == 9){
			sscanf(ss,"%f",&g_pp1[idx][p_ct].mtrl.Power);
		}
		
		// eNX`̃t@C
		else if(!strcmp(ss,"<texture_file>")){
			flag = 10;
		}
		else if(!strcmp(ss,"</texture_file>")){
			flag = 0;
		}
		else if(flag == 10){
			sscanf(ss,"%s",&tex_name);
			strcpy(path, ".\\images\\");
			strcat(path, tex_name);
			if(FAILED(D3DXCreateTextureFromFile(g_pD3DDev,path,&g_pp1[idx][p_ct].pTex))){
				g_pp1[idx][p_ct].pTex = NULL;
			}
		}
		
		// eNX`}bsÕtO
		else if(!strcmp(ss,"<texture_map_flag>")){
			flag = 11;
		}
		else if(!strcmp(ss,"</texture_map_flag>")){
			flag = 0;
		}
		else if(flag == 11){
			sscanf(ss,"%d",&g_pp1[idx][p_ct].flag_lap);
		}
		
		// p[cƂ̒_W
		else if(!strcmp(ss,"<vertices>")){
			flag = 12;
		}
		else if(!strcmp(ss,"</vertices>")){
			flag = 0;
			g_pp1[idx][p_ct + 1].vtx_ct = ct1;
		}
		else if(flag == 12){
			sscanf(ss,"%f %f %f %f %f %f %f %f",&ww[0],&ww[1],&ww[2],&ww[3],&ww[4],&ww[5],&ww[6],&ww[7]);
			g_m1[idx].pv[ct1].x = ww[0];
			g_m1[idx].pv[ct1].y = ww[1];
			g_m1[idx].pv[ct1].z = ww[2];
			g_m1[idx].ptu[ct1]  = ww[6];
			g_m1[idx].ptv[ct1]  = ww[7];
			ct1 ++;
		}
		
		// p[cƂ̖ʂ\钸_W̔ԍ
		else if(!strcmp(ss,"<faces>")){
			flag = 13;
		}
		else if(!strcmp(ss,"</faces>")){
			flag = 0;
			g_pp1[idx][p_ct + 1].face_ct = ct2;
		}
		else if(flag == 13){
			sscanf(ss,"%d %d %d %d",&vv[0],&vv[1],&vv[2],&vv[3]);
			g_m1[idx].pf[ct2][0] = vv[0];
			g_m1[idx].pf[ct2][1] = vv[1];
			g_m1[idx].pf[ct2][2] = vv[2];
			g_m1[idx].pf[ct2][3] = vv[3];
			ct2 ++;
		}
	}
	
	fclose(file1);
	
	if(!g_m1[idx].parts_ct || !g_m1[idx].t_vtx_ct || !g_m1[idx].t_face_ct)
		return 0;
	
	return 1;
}// Load_EctFile

// ECTt@C̓ǂݍ݁ioCi`j
bool Load_EctFile_Bin(int idx, char *filename)
{
	FILE	*file1;
	bool	flag;
	int		i,k,len,len_tag,size,tg,tag_num;
	char	tag[TAG_LEN],path[MAX_PATH],tex_name[MAX_PATH],type[4];
	char	tag_list[][TAG_LEN] = {"parts_count","total_vertex_count","total_face_count",
								"material","texture_file","texture_map_flag",
								"vertex_count","face_count","vertices","texture_map","faces"};
	
	Init_Global(idx);		// Oϐ̏
	
	if((file1=fopen(filename,"rb")) == NULL){
		return 0;		
	}
	
	fread(type,sizeof(char),4,file1);
	if(strcmp(type, "ECT")){
		fclose(file1);
		return 0;
	}
	fread(&tag_num,sizeof(int),1,file1);
	for(tg=0;tg<tag_num;tg++){
		fread(&len_tag,sizeof(int),1,file1);
		if(len_tag > sizeof(tag))	len_tag = sizeof(tag);
		fread(tag,sizeof(char),len_tag,file1);
		fread(&size,sizeof(int),1,file1);
		flag = false;
		for(k=0;k<sizeof(tag_list)/sizeof(tag_list[0]);k++){
			if(!strcmp(tag,tag_list[k])){
				flag = true;
switch(k)
{
case 0:
	fread(&g_m1[idx].parts_ct,sizeof(int),1,file1);
	g_pp1[idx] = new PARTS [g_m1[idx].parts_ct+1];
	ZeroMemory(g_pp1[idx],sizeof(PARTS)*(g_m1[idx].parts_ct+1));
	for(i=0;i<g_m1[idx].parts_ct;i++){
		g_pp1[idx][i].vtx_ct = 0;
		g_pp1[idx][i].face_ct = 0;
		g_pp1[idx][i].mtrl.Diffuse.a = 1.0f;
		g_pp1[idx][i].mtrl.Diffuse.r = 0.8f;
		g_pp1[idx][i].mtrl.Diffuse.g = 0.8f;
		g_pp1[idx][i].mtrl.Diffuse.b = 0.8f;
		g_pp1[idx][i].mtrl.Ambient = g_pp1[idx][i].mtrl.Diffuse;
	}
	break;
case 1:
	fread(&g_m1[idx].t_vtx_ct,sizeof(int),1,file1);
	g_m1[idx].pv  = new D3DXVECTOR3 [g_m1[idx].t_vtx_ct];
	g_m1[idx].ptu = new float       [g_m1[idx].t_vtx_ct];
	g_m1[idx].ptv = new float       [g_m1[idx].t_vtx_ct];
	ZeroMemory(g_m1[idx].ptu,g_m1[idx].t_vtx_ct * sizeof(float));
	ZeroMemory(g_m1[idx].ptv,g_m1[idx].t_vtx_ct * sizeof(float));
	break;
case 2:
	fread(&g_m1[idx].t_face_ct,sizeof(int),1,file1);
	g_m1[idx].pf = new int [g_m1[idx].t_face_ct][4];
	break;
case 3:
	for(i=0;i<g_m1[idx].parts_ct;i++)
		fread(&g_pp1[idx][i].mtrl,sizeof(D3DMATERIAL9),1,file1);
	break;
case 4:
	for(i=0;i<g_m1[idx].parts_ct;i++){
		fread(&len,sizeof(int),1,file1);
		fread(tex_name,sizeof(char),len,file1);
		tex_name[len] = '\0';
		strcpy(path, ".\\images\\");
		strcat(path,tex_name);
		if(FAILED(D3DXCreateTextureFromFile(g_pD3DDev, path, &g_pp1[idx][i].pTex))){
			g_pp1[idx][i].pTex = NULL;
		}
	}
	break;
case 5:
	for(i=0;i<g_m1[idx].parts_ct;i++)
		fread(&g_pp1[idx][i].flag_lap,sizeof(int),1,file1);
	break;
case 6:
	for(i=0;i<g_m1[idx].parts_ct;i++){
		fread(&g_pp1[idx][i+1].vtx_ct,sizeof(int),1,file1);
		g_pp1[idx][i+1].vtx_ct += g_pp1[idx][i].vtx_ct;
	}
	break;
case 7:
	for(i=0;i<g_m1[idx].parts_ct;i++){
		fread(&g_pp1[idx][i+1].face_ct,sizeof(int),1,file1);
		g_pp1[idx][i+1].face_ct += g_pp1[idx][i].face_ct;
	}
	break;
case 8:
	fread(g_m1[idx].pv,sizeof(D3DXVECTOR3),g_m1[idx].t_vtx_ct,file1);
	break;
case 9:
	for(i=0;i<g_m1[idx].t_vtx_ct;i++){
		fread(&g_m1[idx].ptu[i],sizeof(float),1,file1);
		fread(&g_m1[idx].ptv[i],sizeof(float),1,file1);
	}
	break;
case 10:
	fread(g_m1[idx].pf,sizeof(int[4]),g_m1[idx].t_face_ct,file1);
	break;
}
				break;
			}
		}
		if(!flag)
			fseek(file1, size, SEEK_CUR);// ǂݔ΂
	}
	
	if(fclose(file1))
		return 0;
	
	if(!g_m1[idx].parts_ct || !g_m1[idx].t_vtx_ct || !g_m1[idx].t_face_ct)
		return 0;
	
	return 1;
}// Load_File_E_Bin

// IuWFNg̉
void Cleanup()
{
	int i,j;
	// eNX`
	for(i=0;i<2;i++){
		for(j=0;j<g_m1[0].parts_ct;j++){
			RELEASE(g_pp1[i][j].pTex);
		}
	}
	for(i=0;i<32;i++)
		RELEASE(g_pTex2[i]);
	//̈
	for(i=0;i<2;i++){
		DELETE2(g_pp1[i]);
		DELETE2(g_m1[i].pv);
		DELETE2(g_m1[i].ptu);
		DELETE2(g_m1[i].ptv);
		DELETE2(g_m1[i].pf);
	}
	// D3D9 IuWFNg
	RELEASE(g_pD3DDev);
	RELEASE(g_pD3D);
}// Cleanup
